import "reflect-metadata";
import { Class, CustomPropertyDecorator, DecoratorOption, DecoratorTargetType, NativeParameterDecorator, TypeOverride } from "./types";
export declare function decorateParameter(callback: ((target: Class, name: string, index: number) => any), option?: DecoratorOption): ParameterDecorator;
export declare function decorateParameter(data: any, option?: DecoratorOption): ParameterDecorator;
export declare function decorateMethod(callback: ((target: Class, name: string) => any), option?: DecoratorOption): MethodDecorator;
export declare function decorateMethod(data: any, option?: DecoratorOption): MethodDecorator;
export declare function decorateProperty(callback: ((target: Class, name: string, index?: any) => any), option?: DecoratorOption): CustomPropertyDecorator;
export declare function decorateProperty(data: any, option?: DecoratorOption): CustomPropertyDecorator;
export declare function decorateClass(callback: ((target: Class) => any), option?: DecoratorOption): ClassDecorator;
export declare function decorateClass(data: any, option?: DecoratorOption): ClassDecorator;
export declare function decorate(data: any | ((...args: any[]) => any), targetTypes?: DecoratorTargetType[], option?: Partial<DecoratorOption>): (...args: any[]) => void;
export declare function mergeDecorator(...fn: (ClassDecorator | PropertyDecorator | NativeParameterDecorator | MethodDecorator)[]): (...args: any[]) => void;
export declare function ignore(): (...args: any[]) => void;
export declare function type(type: TypeOverride | ((x: any) => TypeOverride), ...genericParams: (string | string[])[]): (...args: any[]) => void;
export declare function noop(): (...args: any[]) => void;
export declare function parameterProperties(): ClassDecorator;
export declare namespace generic {
    function template(...templates: string[]): ClassDecorator;
    function type(...types: TypeOverride[]): ClassDecorator;
    /**
     * Create generic class dynamically
     * @param parent Super class that the class inherited from
     * @param params List of generic type parameters
     */
    function create<T extends Class>(parent: T | {
        parent: T;
        name: string;
    }, ...params: TypeOverride[]): Class<any>;
}
