import { Class, ParameterPropertyReflection, ClassReflection, TypeOverride } from "./types";
declare function useCache<K, P extends any[], R>(cache: Map<K, R>, fn: (...args: P) => R, getKey: (...args: P) => K): (...args: P) => R;
declare namespace metadata {
    function isParameterProperties(meta: any): meta is ParameterPropertyReflection;
    function isCallback(type: any): type is ((x: any) => TypeOverride);
    function isConstructor(value: any): boolean;
    function isCustomClass(type: Function | Function[]): boolean;
    function getMethods(meta: ClassReflection): {
        name: string;
        type: any;
        pars: {
            name: string;
            type: any;
        }[];
    }[];
    function getProperties(meta: ClassReflection): {
        name: string;
        type: any;
    }[];
}
declare type CustomTypeDefinition = {
    [key: string]: Class | Class[];
};
interface CreateClassOption {
    parent: Class;
    definition: CustomTypeDefinition;
    name: string;
    genericParams: TypeOverride[];
}
declare function createClass(opt?: Partial<CreateClassOption>): Class;
export { useCache, metadata, createClass, CustomTypeDefinition, CreateClassOption };
