"use strict";
/* ---------------------------------------------------------------- */
/* --------------------------- HELPERS ---------------------------- */
/* ---------------------------------------------------------------- */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createClass = exports.metadata = exports.useCache = void 0;
const decorate = __importStar(require("./decorators"));
function useCache(cache, fn, getKey) {
    return (...args) => {
        const key = getKey(...args);
        const result = cache.get(key);
        if (!!result)
            return result;
        else {
            const newResult = fn(...args);
            cache.set(key, newResult);
            return newResult;
        }
    };
}
exports.useCache = useCache;
var metadata;
(function (metadata) {
    function isParameterProperties(meta) {
        return meta && meta.kind === "Property" && meta.isParameter;
    }
    metadata.isParameterProperties = isParameterProperties;
    function isCallback(type) {
        return typeof type === "function" && !type.prototype;
    }
    metadata.isCallback = isCallback;
    function isConstructor(value) {
        return ("" + value).indexOf("class") == 0;
    }
    metadata.isConstructor = isConstructor;
    function isCustomClass(type) {
        switch (type) {
            case Boolean:
            case String:
            case Array:
            case Number:
            case Object:
            case Date:
                return false;
            default:
                return true;
        }
    }
    metadata.isCustomClass = isCustomClass;
    function getMethods(meta) {
        return meta.methods.map(x => ({
            name: x.name,
            type: x.returnType,
            pars: x.parameters
                .map(p => ({ name: p.name, type: p.type }))
        }));
    }
    metadata.getMethods = getMethods;
    function getProperties(meta) {
        return meta.properties.map(x => ({
            name: x.name,
            type: x.type
        }));
    }
    metadata.getProperties = getProperties;
})(metadata || (metadata = {}));
exports.metadata = metadata;
function createClass(opt) {
    const option = Object.assign({ parent: Object, name: "DynamicType", definition: {}, genericParams: [] }, opt);
    const type = { [option.name]: class extends option.parent {
        } }[option.name];
    for (const key in option.definition) {
        Reflect.decorate([decorate.type(option.definition[key])], type.prototype, key);
    }
    Reflect.decorate([decorate.generic.type(...option.genericParams)], type);
    return type;
}
exports.createClass = createClass;
